local appName, addonName, addon = ...

local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local ACR = LibStub("AceConfigRegistry-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
	
local QGS = QuestGuru

local name, QuestGuru = ...
local DEFAULT_WIDTH = 610
local DEFAULT_HEIGHT = 450
--local QGS = CreateFrame("Frame") 

LoadAddOn("LibDebug")
if LibDebug then LibDebug() end
--[===[@debug@
--@end-debug@]===]

--ACD:SetDefaultSize(DEFAULT_WIDTH, DEFAULT_HEIGHT, appName)

local format, math = format, math

--local L = addon


local QGC_FACTION = UnitFactionGroup("player");
-- Sound set definitions


-- The saved variables
local QuestGuruDB = {} -- will be initialized in PLAYER_LOGIN

-- The sounds to play
local sounds = nil -- will be initialized in PLAYER_LOGIN

-- The QGSssage level codes
local messageLevels = {
  -- increQGSnt in multiples of 10 so we can add levels later without breaking stuff
  none = 0,
  completion = 10,
  objectives = 20,
  all = 30
}

function QGS:OnEvent(event)
	if event=="PLAYER_LOGIN" then
--		print( QGC_LOADMSG )
		_G.db = LibStub("AceDB-3.0"):New("QuestGuruDB", { profile = {
		ShowLevels = true, ShowTooltips = false, soundQuestComplete = "Alarm Clock 3", 
		soundObjectiveComplete = "Alarm Clock 3",soundObjectiveUpdate = "Alarm Clock 3",
	}}, "Default").profile


--		AceConfig:RegisterOptionsTable(name, QuestGuru.CreateConfig)
		AceConfigDialog:AddToBlizOptions("QuestGuru", "QuestGuru")
		AceConfigDialog:SetDefaultSize(name, 600, 300)

		_G.SlashCmdList["QUESTGURU"] = function() AceConfigDialog:Open(name) end
		_G["SLASH_QUESTGURU1"] = "/questguru"
		_G["SLASH_QUESTGURU2"] = "/qg"
		QuestGuru:CreateConfig()
		self:UnregisterEvent("PLAYER_LOGIN")
	end
end

local QGS = CreateFrame("Frame")
local events = {}

QGS.questIndex = 0
QGS.questId = 0
QGS.completeCount = 0


QGS.msgLvl = messageLevels.all

local function countCompleteObjectives(index)
  local n = 0
  for i = 1, GetNumQuestLeaderBoards(index) do
    local _, _, finished = GetQuestLogLeaderBoard(i, index)
    if finished then
      n = n + 1
    end
  end
  return n
end

function QGS:setQuest(index)
  self.questIndex = index
  if index>0 then
    local _, _, _, _, _, _, _, id = GetQuestLogTitle(index)
    self.questId = id
    if id and id>0 then
      self.completeCount = countCompleteObjectives(index)
    end
  end
end

function QGS:checkQuest()
  if self.questIndex>0 then
    local index = self.questIndex
    self.questIndex = 0
    -- Beware! One of the output arguQGSnts was removed in WoD
    local title, level, _, _, _, complete, daily, id = GetQuestLogTitle(index)
    local link = GetQuestLink(index)
    if id==self.questId then
      if id and id>0 then
        local objectivesComplete = countCompleteObjectives(index)
        if complete then
          if QGS.msgLvl >= messageLevels.completion then
            print("["..level.."] '"..link.."': complete"); -- PlaySoundFile( LSM:Fetch( "sound", QuestGuruDB.soundObjectiveComplete))
          end
          self:PlaySoundFile( LSM:Fetch( "sound", QuestGuruDB.soundQuestComplete))
        elseif objectivesComplete>self.completeCount then
          if QGS.msgLvl >= messageLevels.objectives then
            print("["..level.."] '"..link.."': objective complete ("..objectivesComplete.."/"..GetNumQuestLeaderBoards(index)..")");
          end
          self:PlaySoundFile( LSM:Fetch( "sound", QuestGuruDB.soundObjectiveComplete))
        else
          if QGS.msgLvl >= messageLevels.all then
             print("["..level.."] '"..link.."': updated");
          end
          self:PlaySoundFile( LSM:Fetch( "sound", QuestGuruDB.soundObjectiveUpdate))
        end
      end
    end
  end
end

function QGS:init()
--local sounds = {}
--	sounds["Peon Yes"]				= "Sound\\Creature\\Peon\\PeonYes3.ogg"
--	sounds["Peon What"]				= "Sound\\Creature\\Peon\\PeonWhat4.ogg"
--	sounds["Peon Ready"]			= "Sound\\Creature\\Peon\\PeonReady1.ogg"
--	sounds["Peon Complete"]		= "Sound\\Creature\\Peon\\PeonBuildingComplete1.ogg"
--	sounds["Peasant What"]		= "Sound\\Creature\\Peasant\\PeasantWhat3.ogg"
--	sounds["Peasant Ready"] 	= "Sound\\Creature\\Peasant\\PeasantReady1.ogg"
--	sounds["Peasant Done"]		= "Interface\\AddOns\\QuestProgressSound\\Sounds\\Peasant_work_done.ogg"
--	sounds["Millhouse Ready"]	= "Sound\\Creature\\MillhouseManastorm\\TEMPEST_Millhouse_Ready01.ogg"
--	sounds["Millhouse Slay"]	= "Sound\\Creature\\MillhouseManastorm\\TEMPEST_Millhouse_Slay01.ogg"
--	sounds["Ding"]						= "Interface\\AddOns\\QuestProgressSound\\Sounds\\ding.ogg"
--	sounds["Tada"] 						= "Interface\\AddOns\\QuestProgressSound\\Sounds\\tada.ogg"
--	sounds["Info"] 						= "Interface\\AddOns\\QuestProgressSound\\Sounds\\info.ogg"
--	sounds["Alert"]						= "Interface\\AddOns\\QuestProgressSound\\Sounds\\Alert.ogg"
--	for name, path in pairs( sounds) do
--		LSM:Register( "sound", name, path)
--	end

LSM:Register("sound", "Alarm Clock 1",    "Sound\\Interface\\AlarmClockWarning1.wav")
LSM:Register("sound", "Alarm Clock 2",    "Sound\\Interface\\AlarmClockWarning2.wav")
LSM:Register("sound", "Alarm Clock 3",    "Sound\\Interface\\AlarmClockWarning3.wav")
LSM:Register("sound", "Bell - Alliance",  "Sound\\Doodad\\BellTollAlliance.wav")
LSM:Register("sound", "Bell - Horde",     "Sound\\Doodad\\BellTollHorde.wav")
LSM:Register("sound", "Bell - Night Elf", "Sound\\Doodad\\BellTollNightElf.wav")
LSM:Register("sound", "Drum Hit",         "Sound\\Doodad\\BellTollTribal.wav")
LSM:Register("sound", "Gong - Troll",     "Sound\\Doodad\\G_GongTroll01.wav")
LSM:Register("sound", "Karazhan Bell",    "Sound\\Doodad\\KharazahnBellToll.wav")
LSM:Register("sound", "Mellow Bells",     "Sound\\Spells\\ShaysBell.wav")
LSM:Register("sound", "Level Up2",		"Sound/Interface/levelup2.ogg")
LSM:Register("sound", "Auction Window Close",		"Sound/Interface/AuctionWindowClose.ogg")
LSM:Register("sound", "Auction Window Open",		"Sound/Interface/AuctionWindowOpen.ogg")
LSM:Register("sound", "Peasent Ready",		"Sound/Creature/Peasant/PeasantReady1.ogg")
LSM:Register("sound", "Peasent Yes1",		"Sound/Creature/Peasant/PeasantYes1.ogg")
LSM:Register("sound", "Peasent Yes4",		"Sound/Creature/Peasant/PeasantYes4.ogg")
LSM:Register("sound", "Peasent Done",		"Interface\\AddOns\\QuestProgressSound\\Sounds\\Peasant_work_done.ogg")
LSM:Register("sound", "Peon Building Complete",		"Sound/Creature/Peon/PeonBuildingComplete1.ogg")
LSM:Register("sound", "Peon Ready",		"Sound/Creature/Peon/PeonReady1.ogg")
LSM:Register("sound", "Peon Yes",		"Sound/Creature/Peon/PeonYes3.ogg")
LSM:Register("sound", "Peon What",		"Sound\\Creature\\Peon\\PeonWhat4.ogg")
LSM:Register("sound", "Ding",		"Interface\\AddOns\\QuestProgressSound\\Sounds\\ding.ogg")
LSM:Register("sound", "Tada",		"Interface\\AddOns\\QuestProgressSound\\Sounds\\tada.ogg")
LSM:Register("sound", "Info",		"Interface\\AddOns\\QuestProgressSound\\Sounds\\info.ogg")
LSM:Register("sound", "Alert",		"Interface\\AddOns\\QuestProgressSound\\Sounds\\Alert.ogg")


  self:SetScript("OnEvent", function(frame, event, ...)
    local handler = events[event]
    if handler then
      -- dispatch events that were auto-registered by naming convention
      handler(frame, ...)
    end
  end)
  for k,v in pairs(events) do
    self:RegisterEvent(k)
  end
end



function QGS:Play(sound)
  if sound and sound~="" then
--    print("QGS debug message: Playing:", sound)
    PlaySoundFile(sound);
  end
end

--function QGS:SetSoundSet(setName, silent)
--  if setName and soundSets[setName] then
--    QuestGuruDB.ActiveSet = setName
--    sounds = soundSets[setName]
--    if not(silent) then
--      print("Switching to sound set |cFF44FF00"..setName.."|r")
--      QGS:Play(sounds.questComplete)
--    end
--  else
--    print("Recognized sound set names are:")
--    for k,v in pairs(soundSets) do
--      if k==QuestGuruDB.ActiveSet then
--        print("  "..k.."      (*)")
--      else
--        print("  "..k)
--      end
--    end
--  end
--end

--function QGS:SetMessageLevel(messageLevel)
--  local levelCode = messageLevels[messageLevel]
--  if levelCode==nil then
--    -- ignore silently now
--  else
--    QuestGuruDB.Messages = messageLevel
--    QGS.msgLvl = levelCode
--  end
--end
--
--
--function QGS:SetMessageLevelCmd(messageLevel)
--  if messageLevel==nil or messageLevel=="" then
--    print("The current message verbosity level is '"..QuestGuruDB.Messages.."'")
--  else
--    local levelCode = messageLevels[messageLevel]
--    if levelCode==nil then
--      print("Unrecognized message verbosity level '"..messageLevel.."'. Expecting one of :")
--      for k,v in pairs(messageLevels) do
--        print("  "..k);
--      end
--    else
--      QGS:SetMessageLevel(messageLevel)
--      print("Setting message verbosity to "..QuestGuruDB.Messages)
--    end
--  end
--end


-- ................................................................
-- event handlers

function events:UNIT_QUEST_LOG_CHANGED(unit)
  if unit=="player" then
    QGS:checkQuest()
  end
end

function events:QUEST_WATCH_UPDATE(index)
  -- This event triggers just *before* the changes are registered
  -- in the quest log, giving a great opportunity to quantify changes
  -- in the subsequent UNIT_QUEST_LOG_CHANGED
  QGS:setQuest(index)
end

--function events:PLAYER_LOGIN()
  -- Saved variables are stable now
--  if not(QuestGuruDB.ActiveSet) then
----  	if UnitFactionGroup("player")=="HORDE" then
----    	QuestGuruDB.ActiveSet = "peasant"
----    else
----    	QuestGuruDB.ActiveSet = "peon"
----    end
--    	QuestGuruDB.ActiveSet = "default"
--  end
--  if not(QuestGuruDB.Messages) then
--    QuestGuruDB.Messages = "objectives"
--    -- one of "objectives", "completion", "none"
--  end
----  QGS:SetMessageLevel(QuestGuruDB.Messages)
------  QGS:SetSoundSet(QuestGuruDB.ActiveSet, true)



--testing new config panel
function QuestGuru:CreateConfig()
	QuestGuru.CreateConfig = nil -- no longer needed

	return {
		name = "QuestGuru", type = "group",
		get = function(key) return db[key.arg] end,
		set = function(key, value) db[key.arg] = value QuestGuru:UpdateTimeStrings() end,
		args = {
			header1 = { name = "Display Options", type = "header", order = 1 },

			ShowLevels = {
				name = "Show Quest Levels",
				type = "toggle", order = 2, arg = "ShowLevels",
			},
			ShowTooltips = {
				name = "Show Quest Log Tooltips",
				type = "toggle", order = 3, arg = "ShowTooltips",
			},

			header2 = { name = "Sound Options", type = "header", order = 8 },

			soundQuestComplete = {
				name = "Sound for Quest Completion",
				type = "select", order = 11, arg = "soundQuestComplete",
				dialogControl = "LSM30_Sound", values = AceGUIWidgetLSMlists.sound,
				disabled = function() return not db.soundQuestComplete end,
			},
			soundObjectiveComplete = {
				name = "Sound for Objective Completion",
				type = "select", order = 11, arg = "soundObjectiveComplete",
				dialogControl = "LSM30_Sound", values = AceGUIWidgetLSMlists.sound,
				disabled = function() return not db.soundObjectiveComplete end,
			},
			soundObjectiveUpdate = {
				name = "Sound for Objective Update",
				type = "select", order = 11, arg = "soundObjectiveUpdate",
				dialogControl = "LSM30_Sound", values = AceGUIWidgetLSMlists.sound,
				disabled = function() return not db.soundObjectiveUpdate end,
			},
		},
		QuestGuruDB = db
	}
end



-- help/about frame
--optionFrame = CreateFrame("Frame", "QuestGuruOptions", UIParent)
--	tinsert(UISpecialFrames, "OptionFrame")
--	optionFrame:SetBackdrop({
--      bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
--      edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
--      tile = true, tileSize = 16, edgeSize = 16,
--      insets = { left = 3, right = 3, top = 5, bottom = 3 }
--})
--	optionFrame:SetBackdropColor(0,0,0,1)
--	optionFrame:SetWidth(400)
--	optionFrame:SetHeight(450)
--	optionFrame:SetPoint("CENTER", UIParent, "CENTER")
--	optionFrame:Hide()
--	optionFrame:SetFrameStrata("DIALOG")
--	optionFrame:SetToplevel(true)



--optionFrame:SetScript("OnEscapePressed", function() QuestGuruOptions:Show() end);
--optionFrame.editBox = editBox
--scrollArea:SetScrollChild(editBox)

--local close = CreateFrame("Button", nil, optionFrame, "UIPanelCloseButton")
--close:SetPoint("TOPRIGHT", optionFrame, "TOPRIGHT")  
  
--SLASH_QUESTGURU1 = "/qgs"
--SLASH_QUESTGURU2 = "/questguru"
--local function handler(msg, editbox)
--	if msg == "c" or msg == "close" then
--		QuestGuruOptions:Hide();
--	elseif msg == "" then
--		QuestGuruOptions:Show()
--	end
--end
--SlashCmdList["QuestGuru"] = handler; -- Also a valid assignment strategy


-- ................................................................
-- must be last line:
QGS:init()
