--QuestGuru = LibStub("AceAddon-3.0"):NewAddon("QuestGuru")

--local AC = LibStub("AceConfig-3.0")
--local ACD = LibStub("AceConfigDialog-3.0")
--local ACR = LibStub("AceConfigRegistry-3.0")
--local LSM = LibStub("LibSharedMedia-3.0")

QUESTGURU_VERSION = GetAddOnMetadata("QuestGuru", "Version");
local QGC_NAME = UnitName("player")
local QGC_LEVEL = UnitLevel("player")
local QGC_CLASS = UnitClass("player")
local QGC_FACTION = UnitFactionGroup("player");
--CurrencyTracking_Player = UnitName("player");
--CurrencyTracking_Server = GetRealmName();

local qgc = QuestGuru
local QGC_LOADMSG = "Activated |cFFFFA500QuestGuru v"..QUESTGURU_VERSION.."|r - |cFFFFD700Lazzy-Kilrogg(US)|r"
QuestGuruDB = {} --CFFFF8A08  |c

LoadAddOn("LibDebug")
if LibDebug then LibDebug() end
--@end-debug@]===]
--@non-debug@

local QuestGuruCollapsedHeaders = {}
qgc.quests = {}

_G.BINDING_HEADER_QUESTGURU = "QuestGuru"
_G.BINDING_CATEGORY_QUESTGURU = "QuestGuru"
_G.BINDING_NAME_QUESTGURU_TOGGLE = "Show/Hide QuestGuru"

function qgc:OnEvent(event)
	if event=="PLAYER_LOGIN" then
		print( QGC_LOADMSG )
		local scrollFrame = qgc.scrollFrame
		scrollFrame.update = qgc.UpdateLogList
		HybridScrollFrame_CreateButtons(scrollFrame, "QuestGuruListTemplate")
--		qgc.showLevels.text:SetText("Show Levels")
--		qgc.showTooltips.text:SetText("Show Tooltips")
--		qgc.showLevels:SetChecked(QuestGuruDB.ShowLevels and true)
--		qgc.showTooltips:SetChecked(QuestGuruDB.ShowTooltips and true)
		QGC_FrameTitleText:SetFormattedText(TEXT("QuestGuru").." v"..QUESTGURU_VERSION.." for "..QGC_NAME..", level "..QGC_LEVEL.." "..QGC_CLASS)
		QuestLogPopupDetailFrame:HookScript("OnShow",function() qgc:Hide() end)
--		qgc.CreateConfig()
--		QGCRegistered = false;
--		QGCRegistered = RegisterAddonMessagePrefix("QuestGuru");
--		if	( QGCRegistered ) then
--			ChatFrame1:AddMessage("QuestGuru v"..QUESTGURU_VERSION.." activated! - ", 0, 128, 128,"|r - |cFFFFD700Lazzy-Kilrogg(US)|r");
--		end
		
		qgc:UpdateOverrides()
		qgc:RegisterEvent("UPDATE_BINDINGS")
	elseif event=="UPDATE_BINDINGS" then
		qgc:UpdateOverrides()
	elseif event=="QUEST_DETAIL" then
		qgc:Hide()
		
	else
		local selected = GetQuestLogSelection()
		if selected==0 then
			qgc:SelectFirstQuest()
		else
			qgc:UpdateLogList()
			qgc:SelectQuestIndex(selected)
		end
	end
end

function qgc:OnShow()
	if WorldMapFrame:IsVisible() then
		ToggleWorldMap() -- can't have world map up at same time due to potential details frame being up
	end
	if QuestLogPopupDetailFrame:IsVisible() then
		HideUIPanel(QuestLogPopupDetailFrame)
	end
	local selected = GetQuestLogSelection()
	if not selected or selected==0 then
		qgc:SelectFirstQuest()
	else
		qgc:SelectQuestIndex(selected)
	end
--	OPTIONS:Disable()
	PlaySound("igQuestLogOpen")
	SetPortraitTexture(QGC_FramePortrait, "player")
	qgc:RegisterEvent("QUEST_DETAIL")
	qgc:RegisterEvent("QUEST_LOG_UPDATE")
	qgc:RegisterEvent("QUEST_WATCH_LIST_CHANGED")
	qgc:RegisterEvent("SUPER_TRACKED_QUEST_CHANGED")
	qgc:RegisterEvent("GROUP_ROSTER_UPDATE")
	qgc:RegisterEvent("PARTY_MEMBER_ENABLE")
	qgc:RegisterEvent("PARTY_MEMBER_DISABLE")
	qgc:RegisterEvent("QUEST_POI_UPDATE")
	qgc:RegisterEvent("QUEST_WATCH_UPDATE")
	qgc:RegisterEvent("QUEST_ACCEPTED")
	qgc:RegisterEvent("UNIT_QUEST_LOG_CHANGED")
	if not tContains(UISpecialFrames,"QuestGuru") then
		tinsert(UISpecialFrames,"QuestGuru")
	end
	qgc.detail:ClearAllPoints()
	qgc.detail:SetPoint("TOPRIGHT",-32,-63)
end

-- no need to watch these events while log isn't on screen
function qgc:OnHide()
	-- only keep this window in UISpecialFrames while it's up
	for i=#UISpecialFrames,1,-1 do
		if UISpecialFrames[i]=="QuestGuru" then
			tremove(UISpecialFrames,i)
		end
	end
	PlaySound("igQuestLogClose")
	qgc:UnregisterEvent("QUEST_DETAIL")
	qgc:UnregisterEvent("QUEST_LOG_UPDATE")
	qgc:UnregisterEvent("QUEST_WATCH_LIST_CHANGED")
	qgc:UnregisterEvent("SUPER_TRACKED_QUEST_CHANGED")
	qgc:UnregisterEvent("GROUP_ROSTER_UPDATE")
	qgc:UnregisterEvent("PARTY_MEMBER_ENABLE")
	qgc:UnregisterEvent("PARTY_MEMBER_DISABLE")
	qgc:UnregisterEvent("QUEST_POI_UPDATE")
	qgc:UnregisterEvent("QUEST_WATCH_UPDATE")
	qgc:UnregisterEvent("QUEST_ACCEPTED")
	qgc:UnregisterEvent("UNIT_QUEST_LOG_CHANGED")

	-- expand all headers when window hides so default doesn't lose track of collapsed quests
	local index = 1
	while index<=GetNumQuestLogEntries() do
		local _,_,_,isHeader,isCollapsed = GetQuestLogTitle(index)
		if isHeader and isCollapsed then
			ExpandQuestHeader(index)
		end
		index = index + 1
	end

end

function qgc:UpdateLogList()
	qgc.update:Show()
end

function qgc:UpdateLog()
	qgc.update:Hide() -- immediately stop the OnUpdate
	-- gather quests into a working table (qgc.quests) to skip over collapsed headers
	wipe(qgc.quests)
	qgc.expanded = nil

	local skipping -- will be true while skipping over collapsed headers
	local numQuests = 0
	for index=1,GetNumQuestLogEntries() do
		local questTitle, level, suggestedGroup, isHeader, isCollapsed, isComplete, frequency, questID = GetQuestLogTitle(index)
		if isHeader then
			skipping = QuestGuruCollapsedHeaders[questTitle]
			if not skipping then
				qgc.expanded = true
			end
		end
		if not skipping or isHeader then
			table.insert(qgc.quests,{index,questTitle,level,suggestedGroup,isHeader,skipping,isComplete,frequency,questID})
		end
		if not isHeader then
			numQuests = numQuests + 1
		end
	end
	
	local numEntries = #qgc.quests --= GetNumQuestLogEntries()
	local scrollFrame = qgc.scrollFrame
	local offset = HybridScrollFrame_GetOffset(scrollFrame)
	local buttons = scrollFrame.buttons
	local selectedIndex = GetQuestLogSelection()

	qgc.count.text:SetText(format("%s \124cffffffff%d/%d",QUESTS_COLON,numQuests,MAX_QUESTLOG_QUESTS))

	for i=1, #buttons do
		local index = i + offset
		local button = buttons[i]
--		button.index = index
		if ( index <= numEntries ) then
			local entry, questTitle, level, suggestedGroup, isHeader, isCollapsed, isComplete, frequency, questID = unpack(qgc.quests[index])

			button.index = entry
			button.questID = questID
			button.isHeader = isHeader
			button.isCollapsed = isCollapsed
			button.questTitle = questTitle
			
			button.normalText:SetWidth(275)
			local maxWidth = 275 -- we may shrink normalText to accomidate check and tag icons

			local color = isHeader and QuestDifficultyColors["header"] or GetQuestDifficultyColor(level)
			if not isHeader and selectedIndex==entry then
				button:SetNormalFontObject("GameFontHighlight")
				button.selected:SetVertexColor(color.r,color.g,color.b)
				button.selected:Show()
			else
				button:SetNormalFontObject(color.font)
				button.selected:Hide()
			end

			if isHeader then
				button:SetText(questTitle)
				button:SetNormalTexture(isCollapsed and "Interface\\Buttons\\UI-PlusButton-Up" or "Interface\\Buttons\\UI-MinusButton-Up")
				button:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
				button.check:Hide()
				button.tag:Hide()
			else
				if QuestGuruDB.ShowLevels then
					button:SetText(format("  [%d] %s",level,questTitle))
				else
					button:SetText(format("  %s",questTitle))
				end
				button:SetNormalTexture("")
				button:SetHighlightTexture("")
				-- if quest is tracked, show check and shorted max normalText width
				if IsQuestWatched(entry) then
					maxWidth = maxWidth - 16
					button.check:Show()
				else
					button.check:Hide()
				end
				-- display an icon to note what type of quest it is
				-- tag. daily icon can be alone or before other icons except for COMPLETED or FAILED
				local tagID
				local questTagID, tagName = GetQuestTagInfo(questID)
				if isComplete and isComplete<0 then
					tagID = "FAILED"
				elseif isComplete and isComplete>0 then
					tagID = "COMPLETED"
				elseif questTagID and questTagID==QUEST_TAG_ACCOUNT then
					local factionGroup = GetQuestFactionGroup(questID)
					if factionGroup then
						tagID = "ALLIANCE"
						if factionGroup==LE_QUEST_FACTION_HORDE then
							tagID = "HORDE"
						end
					else
						tagID = QUEST_TAG_ACCOUNT;
					end
				elseif frequency==LE_QUEST_FREQUENCY_DAILY and (not isComplete or isComplete==0) then
					tagID = "DAILY"
				elseif frequency==LE_QUEST_FREQUENCY_WEEKLY and (not isComplete or isComplete==0) then
					tagID = "WEEKLY"
				elseif questTagID then
					tagID = questTagID
				end
				button.tagID = nil
				button.tag:Hide()
				if tagID then -- this is a special type of quest
					maxWidth = maxWidth - 16
					local tagCoords = QUEST_TAG_TCOORDS[tagID]
					if tagCoords then
						button.tagID = tagID
						button.tag:SetTexCoord(unpack(tagCoords))
						button.tag:Show()
					end
				end

				-- If not a header see if any nearby group mates are on this quest
				local partyMembersOnQuest = 0
				for j=1,GetNumSubgroupMembers() do
					if IsUnitOnQuest(entry,"party"..j) then
						partyMembersOnQuest = partyMembersOnQuest + 1
					end
				end
				if partyMembersOnQuest>0 then
					button.groupMates:SetText("["..partyMembersOnQuest.."]")
					button.partyMembersOnQuest = partyMembersOnQuest
					button.groupMates:Show()
				else
					button.partyMembersOnQuest = nil
					button.groupMates:Hide()
				end

			end

			-- limit normalText width to the maxWidth
			button.normalText:SetWidth(min(maxWidth,button.normalText:GetStringWidth()))

			button:Show()
		else
			button:Hide()
		end
	end

	if numEntries==0 then
		qgc.scrollFrame:Hide()
		qgc.emptyLog:Show()
		qgc.detail:Hide()
	else
		qgc.scrollFrame:Show()
		qgc.emptyLog:Hide()
		qgc.scrollFrame.expandAll:SetNormalTexture(qgc.expanded and "Interface\\Buttons\\UI-MinusButton-Up" or "Interface\\Buttons\\UI-PlusButton-Up")
	end

	qgc:UpdateControlButtons()

	HybridScrollFrame_Update(scrollFrame, 16*numEntries, 16)
end

--[[ list entry handling ]]

function qgc:ListEntryOnClick()
	local index = self.index
	if self.isHeader then
		QuestGuruCollapsedHeaders[self.questTitle] = not QuestGuruCollapsedHeaders[self.questTitle] or nil
	else
		if IsModifiedClick("CHATLINK") and ChatEdit_GetActiveWindow() then
			local link = GetQuestLink(index)
			if link then
				ChatEdit_InsertLink(link)
			end
		elseif IsModifiedClick("QUESTWATCHTOGGLE") then
			qgc:ToggleWatch(index)
		else
			qgc:SelectQuestIndex(index)
		end
	end
	qgc:UpdateLogList()
end

function qgc:ToggleWatch(index)
	if not index then
		index = GetQuestLogSelection()
	end
	if index>0 then
		if IsQuestWatched(index) then -- already watched, remove from watch
			RemoveQuestWatch(index)
		else -- not watched, see if there's room to add, add if so
			if GetNumQuestWatches() >= MAX_WATCHABLE_QUESTS then
				UIErrorsFrame:AddMessage(format(QUEST_WATCH_TOO_MANY,MAX_WATCHABLE_QUESTS),1,0.1,0.1,1)
			else
				AddQuestWatch(index)
			end
		end
	end
end

-- tooltip
function qgc:ListEntryOnEnter()
if self.isHeader or not QuestGuruDB.ShowTooltips then
	return
end

	local index = self.index

	GameTooltip:SetOwner(self,"ANCHOR_RIGHT")
	GameTooltip:AddLine((GetQuestLogTitle(index)),1,.82,0)

	-- add tag if one exists
	if self.tagID then
		local tagID, tagName = GetQuestTagInfo(self.questID)
		if tagName then
			GameTooltip:AddLine(tagName,.9,.9,.9)
		else
			tagName = self.tagID=="COMPLETED" and AUCTION_TIME_LEFT0 or _G[self.tagID]
			if tagName then
				GameTooltip:AddLine(tagName,.9,.9,.9)
			end
		end
		if QUEST_TAG_TCOORDS[self.tagID] then
			GameTooltip:AddTexture("Interface\\QuestFrame\\QuestTypeIcons", unpack(QUEST_TAG_TCOORDS[self.tagID]))
		end
	end
	-- list members on quest if they exist
	if self.partyMembersOnQuest then
		GameTooltip:AddLine(PARTY_QUEST_STATUS_ON,1,.82,0)
		for j=1,GetNumSubgroupMembers() do
			if IsUnitOnQuest(index,"party"..j) then
				GameTooltip:AddLine(GetUnitName("party"..j),.9,.9,.9)
			end
		end
		GameTooltip:AddLine(" ")
	end

	-- description
	if isComplete and isComplete>0 then
		GameTooltip:AddLine(GetQuestLogCompletionText(index),1,1,1,true)
	else
		local _, objectiveText = GetQuestLogQuestText(index)
		GameTooltip:AddLine(objectiveText,.85,.85,.85,true)
		local requiredMoney = GetQuestLogRequiredMoney(index)
		local numObjectives = GetNumQuestLeaderBoards(index)
		for i=1,numObjectives do
			local text, objectiveType, finished = GetQuestLogLeaderBoard(i,index)
			if ( text ) then
				local color = HIGHLIGHT_FONT_COLOR
				if ( finished ) then
					color = GRAY_FONT_COLOR
				end
				GameTooltip:AddLine(QUEST_DASH..text, color.r, color.g, color.b, true)
			end
		end
		if ( requiredMoney > 0 ) then
			local playerMoney = GetMoney()
			local color = HIGHLIGHT_FONT_COLOR
			if ( requiredMoney <= playerMoney ) then
				playerMoney = requiredMoney
				color = GRAY_FONT_COLOR
			end
			GameTooltip:AddLine(QUEST_DASH..GetMoneyString(playerMoney).." / "..GetMoneyString(requiredMoney), color.r, color.g, color.b);
		end

	end


	GameTooltip:Show()
end

--[[ selection ]]

function qgc:SelectQuestIndex(index)

	SelectQuestLogEntry(index)

	StaticPopup_Hide("ABANDON_QUEST")
	StaticPopup_Hide("ABANDON_QUEST_WITH_ITEMS")
	SetAbandonQuest()

	if ( index == 0 ) then
		qgc.selectedIndex = nil
		QuestGuruDetailScrollFrame:Hide()
	elseif index>0 and index<=GetNumQuestLogEntries() and not select(4,GetQuestLogTitle(index)) then
		QuestGuruDetailScrollFrame:Show()
		QuestInfo_Display(QUEST_TEMPLATE_LOG, QuestGuruDetailScrollChildFrame)
		QuestGuruDetailScrollFrameScrollBar:SetValue(0) -- scroll to top
	end

	qgc:UpdateLogList()
end

-- selects the first quest in the log (if any)
function qgc:SelectFirstQuest()
	for i=1,GetNumQuestLogEntries() do
		if not select(4,GetQuestLogTitle(i)) then
			qgc:SelectQuestIndex(i)
			return
		end
	end
	qgc:SelectQuestIndex(0) -- if we reached here, select nothing
end

--[[ control buttons ]]

function qgc:UpdateControlButtons()
	local selectionIndex = GetQuestLogSelection()
	if selectionIndex==0 then
		qgc.abandon:Disable()
		qgc.push:Disable()
		qgc.track:Disable()
	else
		local questID = select(8,GetQuestLogTitle(selectionIndex))
		qgc.abandon:SetEnabled(GetAbandonQuestName() and CanAbandonQuest(questID))
		qgc.share:SetEnabled(GetQuestLogPushable() and IsInGroup())
		qgc.track:Enable()
	end
end

function qgc:ExpandAllOnClick()
	if not qgc.expanded then
		wipe(QuestGuruCollapsedHeaders)
	else
		for i=1,GetNumQuestLogEntries() do
			local questTitle,_,_,isHeader = GetQuestLogTitle(i)
			if isHeader then
				QuestGuruCollapsedHeaders[questTitle] = true
			end
		end
	end
	qgc:UpdateLogList()
end

--[[ map button ]]

function qgc:ShowMap()
	qgc:Hide() -- can't let map quest details fight with our details
	local selectionIndex = GetQuestLogSelection()
	if selectionIndex==0 then
		ToggleWorldMap()
	else
		local questID = select(8,GetQuestLogTitle(selectionIndex))
		if not WorldMapFrame:IsVisible() then
			ToggleWorldMap()
		end
		QuestMapFrame_ShowQuestDetails(questID)
	end
end

--[[ overrides ]]

-- if a user sets a key in Key Bindings -> AddOns -> QuestGuru, then
-- we leave the default binding and micro button alone.
-- if no key is set, we override the default's binding and hook the macro button

function qgc:UpdateOverrides()
	local key = GetBindingKey("QUESTGURU_TOGGLE")
	if key then
		ClearOverrideBindings(qgc)
		qgc.overridingKey = nil
	else -- there's no binding for addon, so override the default stuff
		-- hook the ToggleQuestLog (if it's not been hooked before)
		if not qgc.oldToggleQuestLog then
			qgc.oldToggleQuestLog = ToggleQuestLog
			function ToggleQuestLog(...)
				if qgc.overridingKey then
					qgc:ToggleWindow()-- to toggle our window if overriding
					return
				else
					return qgc.oldToggleQuestLog(...) -- and default stuff if they clear overriding
				end
			end
		end
		-- now see if default toggle quest binding has changed
		local newKey = GetBindingKey("TOGGLEQUESTLOG")
		if qgc.overridingKey~=newKey and newKey then
			ClearOverrideBindings(qgc)
			SetOverrideBinding(qgc,false,newKey,"QUESTGURU_TOGGLE")
			qgc.overridingKey = newKey
		end
	end
end

function qgc:ToggleWindow()
	if ClassicQuestLog:IsVisible() then
		HideUIPanel(QuestGuru)
	else
		ShowUIPanel(QuestGuru)
	end
end
-- help/about frame

--aboutFrame = CreateFrame("Frame", "QuestGuruOptionsFrame", UIParent)
--tinsert(UISpecialFrames, "AboutFrame")
--aboutFrame:SetBackdrop({
--      bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
--      edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
--      tile = true, tileSize = 16, edgeSize = 16,
--      insets = { left = 3, right = 3, top = 5, bottom = 3 }
--})
--aboutFrame:SetBackdropColor(0,0,0,1)
--aboutFrame:SetWidth(400)
--aboutFrame:SetHeight(450)
--aboutFrame:SetPoint("RIGHT", UIParent, "RIGHT")
--aboutFrame:Hide()
--aboutFrame:SetFrameStrata("DIALOG")
--aboutFrame:SetToplevel(true)
--
--local scrollArea = CreateFrame("ScrollFrame", "QuestGuruOptionsScroll", aboutFrame, "UIPanelScrollFrameTemplate")
--scrollArea:SetPoint("TOPLEFT", aboutFrame, "TOPLEFT", 8, -30)
--scrollArea:SetPoint("BOTTOMRIGHT", aboutFrame, "BOTTOMRIGHT", -30, 8)
--
--local editBox = CreateFrame("EditBox", nil, aboutFrame)
--editBox:SetMultiLine(true)
--editBox:SetMaxLetters(99999)
--editBox:EnableMouse(true)
--editBox:SetAutoFocus(false)
--editBox:EnableKeyboard(disable)
--editBox:EnableMouse(disable)
--editBox:SetFontObject(ChatFontNormal)
--editBox:SetWidth(360)
--editBox:SetHeight(425)
--editBox:SetText("Lei Shen Coordinator Instructions:\n\nThis addon is to make the Lei Shen encounter easier.\n\nYou need to make sure that before using it, you are either the raid LEADER or have ASSIST as the world markers and RAID WARNINGs require it.\n\nMake sure there is one healer at least per group.\nSeparate your tanks also. \n\nWorld Marker Buttons:\n\nSet a world marker for each corner: (Blue {square}, Green {triangle}, Purple {diamond}, Red {cross} are used in this addon. Left-click sets the marker, right-click clears it.\n\nBefore the pull, make sure to hit the Announce Markers button to let raid members know which group goes to which marker.\n\nThere is a button for Ready Check and the buttons below that are for announcing pre-pull group/raid marker areas. The buttons below the Announce Markers are for the areas that have been destroyed. So if (Blue {square} conduit has been destroyed, then in the Transition phase click the Blue Destroyed button. The same applies for the rest.\n\nCommands for this addon are:\n\n/lsc or /leishen will show the main window\n/lsc c or /leishen c will close the main window (along with using the close button)\n/lsc h, /lsc help or /leishen h, /leishen help, will bring up this help/Instruction window")
--
----phase 1
--
--
--
--editBox:SetScript("OnEscapePressed", function() aboutFrame:Show() end)
--aboutFrame.editBox = editBox
--scrollArea:SetScrollChild(editBox)
--
--local close = CreateFrame("Button", nil, aboutFrame, "UIPanelCloseButton")
--close:SetPoint("TOPRIGHT", aboutFrame, "TOPRIGHT") 
